aboutsummaryrefslogtreecommitdiff
path: root/scripts
diff options
context:
space:
mode:
authorGravatar Eric Andersen <andersen@codepoet.org>2000-12-12 16:49:12 +0000
committerGravatar Eric Andersen <andersen@codepoet.org>2000-12-12 16:49:12 +0000
commit5ec241d3b38054c72735ff448dd1f9bebce78d3d (patch)
treecf53bd1b2c40e9a0ce52cb9c6c4053b410ad93f4 /scripts
parent2d6282bb37a4051e5beb10c70e1fb862eddeae1d (diff)
downloadbusybox-5ec241d3b38054c72735ff448dd1f9bebce78d3d.tar.gz
busybox-5ec241d3b38054c72735ff448dd1f9bebce78d3d.tar.bz2
Script updates for better portability
Diffstat (limited to 'scripts')
-rw-r--r--scripts/undeb12
-rw-r--r--scripts/unrpm9
2 files changed, 15 insertions, 6 deletions
diff --git a/scripts/undeb b/scripts/undeb
index fa2bcb34c..a72e1e2ba 100644
--- a/scripts/undeb
+++ b/scripts/undeb
@@ -1,5 +1,9 @@
#!/bin/sh
#
+# This should work with the GNU version of tar and gzip!
+# This should work with the bash or ash shell!
+# Requires the programs (ar, tar, gzip, and the pager more or less).
+#
usage() {
echo "Usage: undeb -c package.deb <Print control file info>"
echo " undeb -l package.deb <List contents of deb package>"
@@ -25,12 +29,12 @@ elif [ "$1" = "-l" ]; then
exist
type more >/dev/null 2>&1 && pager=more
type less >/dev/null 2>&1 && pager=less
-trap "" 13
-(ar -p $deb control.tar.gz | gunzip -c | tar -x -O control ; echo -e "\nPress enter to scroll, q to Quit!\n" ; ar -p $deb data.tar.gz | gunzip -c | tar -t -v 2>/dev/null) | $pager
+[ "$pager" = "" ] && echo "No pager found!" && exit
+(ar -p $deb control.tar.gz | tar -xzO *control ; echo -e "\nPress enter to scroll, q to Quit!\n" ; ar -p $deb data.tar.gz | tar -tzv) | $pager
exit
elif [ "$1" = "-c" ]; then
exist
-ar -p $deb control.tar.gz | gunzip -c | tar -x -O control
+ar -p $deb control.tar.gz | tar -xzO *control
exit
elif [ "$1" = "-x" ]; then
exist
@@ -40,7 +44,7 @@ elif [ ! -d "$3" ]; then
echo "No such directory $3!"
exit
fi
-ar -p $deb data.tar.gz | gunzip | (cd $3 ; tar -x -v -f -) || exit
+ar -p $deb data.tar.gz | tar -xzvpf - -C $3 || exit
echo
echo "Extracted $deb to $3!"
exit
diff --git a/scripts/unrpm b/scripts/unrpm
index 2cd1aa9c9..9ab37be0a 100644
--- a/scripts/unrpm
+++ b/scripts/unrpm
@@ -1,5 +1,9 @@
#!/bin/sh
#
+# This should work with the GNU version of cpio and gzip!
+# This should work with the bash or ash shell!
+# Requires the programs (cpio, gzip, and the pager more or less).
+#
usage() {
echo "Usage: unrpm -l package.rpm <List contents of rpm package>"
echo " unrpm -x package.rpm /foo/boo <Extract rpm package to this directory,"
@@ -24,7 +28,8 @@ elif [ "$1" = "-l" ]; then
exist
type more >/dev/null 2>&1 && pager=more
type less >/dev/null 2>&1 && pager=less
-(echo -e "\nPress enter to scroll, q to Quit!\n" ; rpmunpack < $rpm | gunzip -c | cpio -tvf --quiet) | $pager
+[ "$pager" = "" ] && echo "No pager found!" && exit
+(echo -e "\nPress enter to scroll, q to Quit!\n" ; rpmunpack < $rpm | gzip -dc | cpio -tv --quiet) | $pager
exit
elif [ "$1" = "-x" ]; then
exist
@@ -34,7 +39,7 @@ elif [ ! -d "$3" ]; then
echo "No such directory $3!"
exit
fi
-rpmunpack < $rpm | gunzip | (cd $3 ; cpio -idmuv) || exit
+rpmunpack < $rpm | gzip -d | (umask 0 ; cd $3 ; cpio -idmuv) || exit
echo
echo "Extracted $rpm to $3!"
exit